%global lua_libdir %{_libdir}/lua/%{lua_version}
%global lua_pkgdir %{_datadir}/lua/%{lua_version}

%global lua_compat_version 5.1
%global lua_compat_libdir %{_libdir}/lua/%{lua_compat_version}
%global lua_compat_pkgdir %{_datadir}/lua/%{lua_compat_version}
%global lua_compat_builddir %{_builddir}/lua%{lua_compat_version}-lpeg-%{version}-%{release}

Summary:        Parsing Expression Grammars for Lua
Name:           lua-lpeg
Version:        1.0.2
Release:        4%{?dist}
License:        MIT
URL:            http://www.inf.puc-rio.br/~roberto/lpeg
Source0:        %{url}/lpeg-%{version}.tar.gz

Patch3000:       0001-inject-ldflags.patch

BuildRequires:  gcc lua-devel
Requires:       lua(abi) = %{lua_version}

%description
LPeg is a new pattern-matching library for Lua, based on Parsing Expression Grammars (PEGs).

%package -n lua%{lua_compat_version}-lpeg
Summary:        Parsing Expression Grammars for Lua %{lua_compat_version}
BuildRequires:  compat-lua-devel make
Requires:       lua(abi) = %{lua_compat_version}
Provides:       compat-%{name}

%description -n lua%{lua_compat_version}-lpeg
LPeg is a new pattern-matching library for Lua %{lua_compat_version}

%prep
%autosetup -n lpeg-%{version} -p1

rm -rf %{lua_compat_builddir}
cp -a . %{lua_compat_builddir}

%build
%make_build COPT="%{optflags}" LDFLAGS="%{build_ldflags}"

pushd %{lua_compat_builddir}
%make_build \
    COPT="-I%{_includedir}/lua-%{lua_compat_version} %{optflags}" \
    LDFLAGS="-L%{lua_compat_libdir} %{build_ldflags}" \
    %{nil}
popd

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{lua_libdir}
mkdir -p %{buildroot}%{lua_pkgdir}
install -p lpeg.so %{buildroot}%{lua_libdir}/lpeg.so.%{version}
ln -s lpeg.so.%{version} %{buildroot}%{lua_libdir}/lpeg.so
install -p -m 0644 re.lua %{buildroot}%{lua_pkgdir}

pushd %{lua_compat_builddir}
mkdir -p %{buildroot}%{lua_compat_libdir}
mkdir -p %{buildroot}%{lua_compat_pkgdir}
install -p lpeg.so %{buildroot}%{lua_compat_libdir}/lpeg.so.%{version}
ln -s lpeg.so.%{version} %{buildroot}%{lua_compat_libdir}/lpeg.so
install -p -m 0644 re.lua %{buildroot}%{lua_compat_pkgdir}
popd

%check
lua test.lua

%files
%doc HISTORY lpeg.html re.html lpeg-128.gif test.lua
%{lua_libdir}/*
%{lua_pkgdir}/*

%files -n lua%{lua_compat_version}-lpeg
%{lua_compat_libdir}/*
%{lua_compat_pkgdir}/*

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0.2-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0.2-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0.2-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Jan 16 2023 Shuo Wang <abushwang@tencent.com> - 1.0.2-1
- initial build
